<?php

	# 		Germany - Forecast
	# 		Namespace:		forecastDE
	#		Meteotemplate Block

	# 		v1.0 - Jun 2, 2017
	# 			- initial release
	
		
	// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];
	
	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../scripts/functions.php");
	
	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);

	createCacheDir();

	if(file_exists("settings.php")){
		include("settings.php");
	}
	else{
		echo "Please go to your admin section and go through the settings for this block first.";
		die();
	}

	$dataURL = $locationDE;

	if(file_exists("cache/data.txt")){
		if (time()-filemtime("cache/data.txt") > 60 * 60) {
			unlink("cache/data.txt");
		}
	}
	if(file_exists("cache/data.txt")){
		$dataRaw = file_get_contents("cache/data.txt");
	}
	else {
		$dataRaw = cleanHTML(loadContent($dataURL,10));
		file_put_contents("cache/data.txt",$dataRaw);
	}

	preg_match("/<div id=\"wetklitab\"> ?<h1>(.*?)</",$dataRaw,$matchedTitle);
	if(isset($matchedTitle[1])){
		$cityName = $matchedTitle[1];
	}
	else{
		$cityName = "N/A";
	}

	preg_match("/<div id=\"wetklitab\"> ?<h1>.*?<.*?<table>(.*?)<\/table>/",$dataRaw,$matchedCurrent);
	if(isset($matchedCurrent[1])){
		$currentTable = $matchedCurrent[1];
		// rows
		preg_match_all("/<tr.*?>(.*?)<\/tr>/",$currentTable,$matchedCurrentRow);
		for($i=0;$i<count($matchedCurrentRow[1]);$i++){
			$thisRow = $matchedCurrentRow[1][$i];
			preg_match_all("/<td.*?>(.*?)<\/td>/",$thisRow,$thisCells);
			$savedRows[] = $thisCells[1];
		}

		$this['date'] = strip_tags($savedRows[0][1]);
		$this['time'] = str_replace(" Uhr","",strip_tags($savedRows[0][2]));
		$this['pictogram'] = str_replace("<img name=\"piktogramm\" src=\"","http://www.dwd.de",$savedRows[1][1]);
		$this['pictogram'] = str_replace("\" alt=\"Wettersymbol\" width=\"75\">","",$this['pictogram']);
		$this['T'] = str_replace(" Grad ","&deg;",strip_tags($savedRows[2][1]));
		$this['H'] = str_replace(" %","%",strip_tags($savedRows[3][1]));
		$this['W'] = strip_tags($savedRows[4][1]);
		$this['P'] = strip_tags($savedRows[5][1]);

		$dateParse = explode(".",$this['date']);
		$this['U'] = date($dateTimeFormat,strtotime($dateParse[2]."-".$dateParse[1]."-".$dateParse[0]." ".$this['time'].":00"));
	}

	$savedRows = array();

	preg_match("/<div id=\"wetklitab\"> ?<table>(.*?)<\/table>/",$dataRaw,$matchedForecast);
	if(isset($matchedForecast[1])){
		$forecastTable = $matchedForecast[1];
		// rows
		preg_match_all("/<tr.*?>(.*?)<\/tr>/",$forecastTable,$matchedForecastRow);
		for($i=0;$i<count($matchedForecastRow[1]);$i++){
			$thisRow = $matchedForecastRow[1][$i];
			preg_match_all("/<td.*?>(.*?)<\/td>/",$thisRow,$thisCells);
			$savedRows[] = $thisCells[1];
		}

		for($i=1;$i<count($savedRows);$i++){
			$dayTime = strip_tags($savedRows[$i][0]);
			$dayTimeExploded = explode(" ",$dayTime);
			$weekDay = $dayTimeExploded[0];
			$icon = preg_replace('/^.*?src="(.*?)".*?$/','$1',$savedRows[$i][1]);
			$icon = "http://www.dwd.de" . $icon;
			$tempThis = filter_var($savedRows[$i][2], FILTER_SANITIZE_NUMBER_INT);
			$forecasts[$weekDay][] = array($dayTimeExploded[1],$icon,$tempThis);
		}
	}
?>
	<style>
		.forecastDEIcon{
			font-size: 1.5em;
		}
		.forecastDEImg{
			height: 30px;
			padding-top: 3px;
		}
		.forecastDETime{
			font-variant: small-caps;
			color: #<?php echo $theme="dark" ? $color_schemes[$design2]['300'] : $color_schemes[$design2]['700']?>;
			font-weight: bold;
		}
	</style>
	
	<h2><?php echo $cityName?></h2>
	<?php 
		if(isset($this)){
	?>
			<span class="forecastDETime"><?php echo $this['U']?></span>
			<table style="width:98%;margin:0 auto;table-layout:fixed">
				<tr>
					<td>
						<img src="<?php echo $this['pictogram']?>">
					</td>
					<td>
						<span class="mticon-temp forecastDEIcon"></span><br><?php echo $this['T']?>
					</td>
					<td>
						<span class="mticon-humidity forecastDEIcon"></span><br><?php echo $this['H']?>
					</td>
					<td>
						<span class="mticon-wind forecastDEIcon"></span><br><?php echo $this['W']?>
					</td>
					<td>
						<span class="mticon-pressure forecastDEIcon"></span><br><?php echo $this['P']?>
					</td>
				</tr>
			</table>
	<?php 
		}
		else{
			echo lang('data currently not available','c');
		}
	?>
	<?php 
		if(isset($forecasts)){
	?>
			<br>
			<div class="details" id="forecastDEDetails" style="width:100%">
				<?php 
					foreach($forecasts as $day=>$vals){
				?>
						<table style="width:98%;margin:0 auto;table-layout:fixed" class="table">
							<tr>
								<th style="text-align:left;width:100px!important;padding-left:5px">
									<?php echo $day?>
								</th>
								<?php 
									for($i=0;$i<count($vals);$i++){
								?>
										<td>
											<span class="forecastDETime"><?php echo $vals[$i][0]?></span><br><img class="forecastDEImg" src="<?php echo $vals[$i][1]?>"><br><?php echo $vals[$i][2]?>&deg;C
										</td>
								<?php
									}
								?>
						</table>
				<?php
					}
				?>
			</div>
			<span class="more" onclick="txt = $('#forecastDEDetails').is(':visible') ? '<?php echo lang('more','l')?>' : '<?php echo lang('hide','l')?>';$('#forecastDEDetails').slideToggle(800);$(this).text(txt)">
				<?php echo lang('more','l')?>
			</span>
	<?php 
		}
	?>
	<div style="width:90%;margin:0 auto;font-size:0.8em;font-variant:small-caps;text-align:center">
		<?php echo lang('data source','c')?>: dwd.de
	</div>